//
// shatbox (C) 2001 Matthew Conte (matt@conte.com)
//
//
// cart.h
//
// NES rom file handling
//
// $Id: $
//

#ifndef _CART_H_
#define _CART_H_

#include "typedefs.h"
#include "mmc.h"

class cart
{
protected:
   enum
   {
      CART_BATTERY   = 0x01,
      CART_TRAINER   = 0x02,
      CART_VERSUS    = 0x04
   };

   mapperInfo  mMapperInfo;
   uint8 mFlags;

   char  *mpFilename;

   int   loadCartType();
   int   loadSRAM();
   void  saveSRAM();
   int   loadPalette();
   int   allocateRAM();
   
   void  showInfo();

   // TODO: ick
   bool  isINES(const char *pFilename);
   bool  isUNIF(const char *pFilename);
   int   loadINES();
   int   loadUNIF();

public:
   cart();
   ~cart();

   int   load(const char *pFilename);
   void  unload();

   mapperInfo *getMapperInfo();
};

#endif // !_CART_H_

