//
// shatbox (C) 2002 Matthew Conte (matt@conte.com)
//
//
// input.h
//
// nes input routines
//
// $Id: $
//

#ifndef _INPUT_H_
#define _INPUT_H_

#include "typedefs.h"
#include "unit.h"

class machine;
class input : public unit
{
public:
   enum eInputState
   {
      INPUT_RELEASE,
      INPUT_PRESS
   };

   enum eInputDevice
   {
      INPUT_PAD0,
      INPUT_PAD1,
      INPUT_ZAPPER,
   };

   input(machine *pMachine);

   static uint8 dispatchRead(void *userdata, uint32 offset);
   static void  dispatchWrite(void *userdata, uint32 offset, uint8 value);
   void  trigger(eInputDevice device, uint8 value, eInputState state);

private:
   struct pad
   {
      int   state;
      int   readCount;
   };

   int   mStrobe;
   pad   mPad[2];
   
   uint8 read(uint32 offset);
   void  write(uint32 offset, uint8 value);

   void  portStrobe();
   uint8 portRead(int port);
   void  portWrite(uint8 value);
};

#endif // !_INPUT_H_
