//
// msdos.h
//
// msdos system class
//
// Copyright (C) 2002 Matthew Conte
//
// $Id: $
//

#ifndef _MSDOS_H_
#define _MSDOS_H_

#include "system.h"
#include "thinlib.h"

class msdos : public System
{
public:
   msdos();
   virtual ~msdos();

   virtual void setColor(int index, int r, int g, int b, int value);
   virtual void lockVideo();
   virtual void unlockVideo();

   virtual int timerResolution() const;

   virtual int pollEvents(eventHandler *pEventHandler);

   virtual void mark();
   virtual int elapsed();
   virtual void usleep(int us);

protected:
   static void audioCallbackDispatch(void *pUserData, void *pStream, int numSamples);

   virtual void disableInterrupts();
   virtual void enableInterrupts();

   int   openVideo();
   void  openAudio();

   void  closeVideo();
   void  closeAudio();

   surface_t   *mpScreen;
};

inline void msdos::disableInterrupts()
{
   THIN_DISABLE_INTS();
}

inline void msdos::enableInterrupts()
{
   THIN_ENABLE_INTS();
}

inline int msdos::timerResolution() const
{
   return 55;
}

#endif // !_MSDOS_H_
