//
// unit.h
//
// a unit is a single component of the emulated machine
//
// Copyright (C) 2002 matthew conte
//

#ifndef _UNIT_H_
#define _UNIT_H_

#include "nes6502.h"

class machine;
class unit
{
public:
   unit(machine *pMachine);
   virtual ~unit();

   virtual void reset(bool hardReset = false);

   const nes6502_memread *getMemRead() const;
   const nes6502_memwrite *getMemWrite() const;

protected:
   machine  *mpMachine;
   const nes6502_memread *mpMemRead;
   const nes6502_memwrite *mpMemWrite;

   virtual uint8 read(uint32 offset);
   virtual void write(uint32 offset, uint8 value);
};

inline const nes6502_memread *unit::getMemRead() const
{
   return mpMemRead;
}

inline const nes6502_memwrite *unit::getMemWrite() const
{
   return mpMemWrite;
}

#endif // !_UNIT_H_
